## libjodycode 4.1.1

=== Makefile ===
# libjodycode Makefile

CFLAGS ?= -O2 -g
PREFIX ?= /usr/local
PROGRAM_NAME = libjodycode
LIB_DIR ?= $(PREFIX)/lib
INC_DIR ?= $(PREFIX)/include
MAN_BASE_DIR ?= $(PREFIX)/share/man
MAN3_DIR ?= $(MAN_BASE_DIR)/man3
CC ?= gcc
INSTALL = install
RM      = rm -f
LN      = ln -sf
RMDIR   = rmdir -p
MKDIR   = mkdir -p
INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644
SO_SUFFIX = .so
LIB_SUFFIX = .a

# Make Configuration
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe -fPIC

UNAME_S       = $(shell uname -s)
UNAME_M       = $(shell uname -m)
VERSION       = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/".*//')
VERSION_MAJOR = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/\..*//')
SO_VER_FULL   = $(SO_SUFFIX).$(VERSION)
SO_VER_MAJOR  = $(SO_SUFFIX).$(VERSION_MAJOR)
CROSS_DETECT  = $(shell true | $(CC) -dM -E - | grep -m 1 __x86_64 || echo "cross")

# Are we running on a Windows OS?
ifeq ($(OS), Windows_NT)
 ifndef NO_WINDOWS
  ON_WINDOWS=1
  SO_SUFFIX=.dll
  LIB_SUFFIX=.lib
  SO_VER_FULL=$(SO_SUFFIX)
  SO_VER_MAJOR=$(SO_SUFFIX)
 endif
endif

ifeq ($(UNAME_S), Darwin)
 SO_SUFFIX    = .dylib
 SO_VER_FULL  = .$(VERSION)$(SO_SUFFIX)
 SO_VER_MAJOR = .$(VERSION_MAJOR)$(SO_SUFFIX)
 LINK_OPTIONS += -Wl,-install_name,$(PROGRAM_NAME)$(SO_VER_MAJOR)
 # Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
 GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep '[cn][cg] version' | sed 's/[^0-9]*//;s/[ .].*//'` \>= 5)
 STRIP_UNNEEDED = strip -S
 STRIP_DEBUG = strip -S
else
 LINK_OPTIONS += -Wl,-soname,$(PROGRAM_NAME)$(SO_VER_MAJOR)
 GCCVERSION = 1
 STRIP_UNNEEDED = strip --strip-unneeded
 STRIP_DEBUG = strip --strip-debug
endif

ifeq ($(GCCVERSION), 1)
 COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

ifdef USE_LTO
 COMPILER_OPTIONS += -flto
 LINK_OPTIONS += -flto
endif

# C standard selection
ifndef USE_C99
COMPILER_OPTIONS += -std=gnu11
else
COMPILER_OPTIONS += -std=gnu99
OBJS += c99_aligned_alloc.o
endif

# Debugging code inclusion
ifdef LOUD
 DEBUG=1
 CFLAGS += -DLOUD_DEBUG
endif
ifdef DEBUG
 CFLAGS += -DDEBUG
else
 CFLAGS += -DNDEBUG
endif
ifdef HARDEN
 CFLAGS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wl,-z,relro -Wl,-z,now
endif

# MinGW needs this for printf() conversions to work
ifdef ON_WINDOWS
 ifndef NO_UNICODE
  UNICODE=1
  COMPILER_OPTIONS += -municode
  PROGRAM_SUFFIX=.exe
 endif
 ifeq ($(UNAME_S), MINGW32_NT-5.1)
  OBJS += winres_xp.o
 else
  OBJS += winres.o
 endif
# COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1
 COMPILER_OPTIONS += -DON_WINDOWS=1
endif

# Do not build SIMD code if not on x86_64
ifneq ($(UNAME_M), x86_64)
 NO_SIMD=1
endif
ifeq ($(CROSS_DETECT), cross)
 NO_SIMD=1
endif

# SIMD SSE2/AVX2 jody_hash code
ifdef NO_SIMD
 COMPILER_OPTIONS += -DNO_SIMD -DNO_SSE2 -DNO_AVX2
else
 SIMD_OBJS += jody_hash_simd.o
 ifdef NO_SSE2
  COMPILER_OPTIONS += -DNO_SSE2
 else
  SIMD_OBJS += jody_hash_sse2.o
 endif
 ifdef NO_AVX2
  COMPILER_OPTIONS += -DNO_AVX2
 else
  SIMD_OBJS += jody_hash_avx2.o
 endif
endif


CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
LDFLAGS += $(LINK_OPTIONS)

# ADDITIONAL_OBJECTS - some platforms will need additional object files
# to support features not supplied by their vendor. Eg: GNU getopt()
#ADDITIONAL_OBJECTS += getopt.o

OBJS += access.o alarm.o batch.o block_hash.o cacheinfo.o dir.o
OBJS += error.o fopen.o jc_fwprint.o getcwd.o jody_hash.o link.o
OBJS += linkfiles.o numstrcmp.o oom.o paths.o
OBJS += remove.o rename.o size_suffix.o stat.o
OBJS += string.o str_t.o time.o version.o win_unicode.o
OBJS += $(ADDITIONAL_OBJECTS)

all: manual sharedlib staticlib
	-@test "$(CROSS_DETECT)" = "cross" && echo "NOTICE: SIMD disabled: !x86_64 or a cross-compiler detected (CC = $(CC))" || true

sharedlib: $(OBJS) $(SIMD_OBJS)
	$(CC) -shared -o $(PROGRAM_NAME)$(SO_VER_FULL) $(OBJS) $(SIMD_OBJS) $(LDFLAGS) $(CFLAGS) $(CFLAGS_EXTRA)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_FULL) $(PROGRAM_NAME)$(SO_VER_MAJOR)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(PROGRAM_NAME)$(SO_SUFFIX)

staticlib: $(OBJS) $(SIMD_OBJS)
	$(AR) rcs libjodycode$(LIB_SUFFIX) $(OBJS) $(SIMD_OBJS)

jody_hash_simd.o:
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_simd.o jody_hash_simd.c

jody_hash_avx2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_avx2.o jody_hash_avx2.c

jody_hash_sse2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -msse2 -c -o jody_hash_sse2.o jody_hash_sse2.c

apiver: helper_code/libjodycode_apiver.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -o apiver helper_code/libjodycode_apiver.c

vercheck: helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -DJC_TEST -I. -c -o vercheck.o helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -L. -Wl,-Bstatic vercheck.o -ljodycode -Wl,-Bdynamic -o vercheck

cacheinfo:
	$(CC) cacheinfo.c -DJC_TEST $(CFLAGS) $(LDFLAGS) -o cacheinfo

lnk: tests/linkfiles_dedupe.c
	$(CC) -Wall -Wextra -pedantic $(CFLAGS) $(LDFLAGS) -I. -std=gnu11 tests/linkfiles_dedupe.c libjodycode.a -o lnk

.c.o:
	$(CC) -c $(COMPILER_OPTIONS) $(CFLAGS) $(CPPFLAGS) $< -o $@

manual:
	gzip -9 < libjodycode.3 > libjodycode.3.gz

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(LIB_DIR) || $(MKDIR) $(DESTDIR)$(LIB_DIR)
	test -e $(DESTDIR)$(INC_DIR) || $(MKDIR) $(DESTDIR)$(INC_DIR)
	test -e $(DESTDIR)$(MAN3_DIR) || $(MKDIR) $(DESTDIR)$(MAN3_DIR)

installfiles: installdirs
	$(INSTALL_PROGRAM) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_MAJOR)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
	$(INSTALL_DATA) $(PROGRAM_NAME)$(LIB_SUFFIX)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
	$(INSTALL_DATA) $(PROGRAM_NAME).h $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(INSTALL_DATA) $(PROGRAM_NAME).3.gz $(DESTDIR)$(MAN3_DIR)/$(PROGRAM_NAME).3.gz

install: installdirs installfiles

uninstalldirs:
	-test -e $(DESTDIR)$(LIB_DIR)  && $(RMDIR) $(DESTDIR)$(LIB_DIR)
	-test -e $(DESTDIR)$(INC_DIR)  && $(RMDIR) $(DESTDIR)$(INC_DIR)
	-test -e $(DESTDIR)$(MAN3_DIR) && $(RMDIR) $(DESTDIR)$(MAN3_DIR)

uninstallfiles:
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_MAJOR)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
	$(RM)  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(RM)  $(DESTDIR)$(MAN3_DIR)/$(PROGRAM_NAME).3.gz

uninstall: uninstallfiles uninstalldirs

test:
	./test.sh

stripped: sharedlib staticlib
	$(STRIP_UNNEEDED) libjodycode$(SO_SUFFIX)
	$(STRIP_DEBUG) libjodycode$(LIB_SUFFIX)

objsclean:
	$(RM) $(OBJS) $(SIMD_OBJS) vercheck.o *.obj

clean: objsclean
	$(RM) $(PROGRAM_NAME)$(SO_SUFFIX) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(PROGRAM_NAME)$(SO_VER_FULL)
	$(RM) $(PROGRAM_NAME)$(LIB_SUFFIX) apiver cacheinfo vercheck $(PROGRAM_NAME).3.gz
	$(RM) *~ helper_code/*~ libjodycode.a libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov

distclean: objsclean clean
	$(RM) *.pkg.tar.*
	$(RM) -r $(PROGRAM_NAME)-*-*/ $(PROGRAM_NAME)-*-*.zip

chrootpackage:
	+./chroot_build.sh
package:
	+./generate_packages.sh

=== skeleton/Makefile ===
# a_ljc_program Makefile

# PROGRAM_NAME determines the installation name and manual page name
PROGRAM_NAME = a_ljc_program

# Default flags to pass to the C compiler (can be overridden)
CFLAGS ?= -O2 -g
#CFLAGS ?= -Og -g3

# PREFIX determines where files will be installed. Common examples
# include "/usr" or "/usr/local".
PREFIX = /usr/local

# BIN_DIR indicates directory where program is to be installed.
# Suggested value is "$(PREFIX)/bin"
BIN_DIR = $(PREFIX)/bin

# MAN_DIR indicates directory where the man page is to be
# installed. Suggested value is "$(PREFIX)/man/man1"
MAN_BASE_DIR = $(PREFIX)/share/man
MAN_DIR = $(MAN_BASE_DIR)/man1
MAN_EXT = 1

# Required external tools
CC ?= gcc
INSTALL = install
RM      = rm -f
RMDIR   = rmdir -p
MKDIR   = mkdir -p
INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644

# Main object files
OBJS += $(PROGRAM_NAME).o libjodycode_check.o

# Configuration section
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe
COMPILER_OPTIONS += -DNO_ATIME

ifdef USE_LTO
 COMPILER_OPTIONS += -flto
 LINK_OPTIONS += -flto
endif

# Remove unused code if requested
ifdef GC_SECTIONS
 COMPILER_OPTIONS += -fdata-sections -ffunction-sections
 LINK_OPTIONS += -Wl,--gc-sections
endif

UNAME_S=$(shell uname -s)

# Are we running on a Windows OS?
ifeq ($(OS), Windows_NT)
 ifndef NO_WINDOWS
  ON_WINDOWS=1
 endif
endif

# Debugging code inclusion
ifdef DEBUG
 COMPILER_OPTIONS += -DDEBUG
else
 COMPILER_OPTIONS += -DNDEBUG
endif
ifdef HARDEN
 COMPILER_OPTIONS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -fPIE -fpie -Wl,-z,relro -Wl,-z,now
else
 #COMPILER_OPTIONS += -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=0
endif

# MinGW needs this for printf() conversions to work
ifdef ON_WINDOWS
 ifndef NO_UNICODE
  UNICODE=1
  COMPILER_OPTIONS += -municode
 endif
 SUFFIX=.exe
 SO_EXT=.dll
 LIB_EXT=.lib
 COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
 ifeq ($(UNAME_S), MINGW32_NT-5.1)
  OBJS += winres_xp.o
 else
  OBJS += winres.o
 endif
else
 SO_EXT=.so
 LIB_EXT=.a
endif

# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
# ENABLE_DEDUPE by default - macOS Sierra 10.12 and up required
ifeq ($(UNAME_S), Darwin)
 GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep '[cn][cg] version' | sed 's/[^0-9]*//;s/[ .].*//'` \>= 5)
else
 GCCVERSION = 1
 BDYNAMIC = -Wl,-Bdynamic
 BSTATIC = -Wl,-Bstatic
endif

ifeq ($(GCCVERSION), 1)
 COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

# Stack size limit can be too small for deep directory trees, so set to 16 MiB
# The ld syntax for Windows is the same for both Cygwin and MinGW
ifndef LOW_MEMORY
 ifeq ($(OS), Windows_NT)
  COMPILER_OPTIONS += -Wl,--stack=16777216
 else ifeq ($(UNAME_S), Darwin)
  COMPILER_OPTIONS += -Wl,-stack_size -Wl,0x1000000
 else
  COMPILER_OPTIONS += -Wl,-z,stack-size=16777216
 endif
endif

### Find and use nearby libjodycode by default
ifndef IGNORE_NEARBY_JC
 ifneq ("$(wildcard ../libjodycode/libjodycode.h)","")
  $(info Found and using nearby libjodycode at ../libjodycode)
  COMPILER_OPTIONS += -I../libjodycode -L../libjodycode
  ifeq ("$(wildcard ../libjodycode/version.o)","")
   $(error You must build libjodycode before building $(PROGRAM_NAME))
  endif
  ifneq ("$(wildcard ../libjodycode/libjodycode.a)","")
   $(info Overriding static library extension .lib for found extension .a)
   LIB_EXT=.a
  endif
  STATIC_LDFLAGS += ../libjodycode/libjodycode$(LIB_EXT)
  DYN_LDFLAGS += -l:../libjodycode/libjodycode$(SO_EXT)
 else
  STATIC_LDFLAGS += -ljodycode
  DYN_LDFLAGS += -ljodycode
 endif
else
 STATIC_LDFLAGS += -ljodycode
 DYN_LDFLAGS += -ljodycode
endif

# Don't build ljc_vercheck dynamically on Windows
ifdef ON_WINDOWS
 LJC_DYNAMIC = $(BSTATIC) $(STATIC_LDFLAGS)
 $(info )
 $(info Notice: Windows dynamic builds will build but silently fail)
 $(info         without libjodycode.dll in the same directory.)
 $(info         To avoid this, link statically: 'make static_jc')
 $(info )
else
 LJC_DYNAMIC = $(BDYNAMIC) $(DYN_LDFLAGS)
endif


CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
LDFLAGS += $(LINK_OPTIONS) $(LDFLAGS_EXTRA)


all: libjodycode_hint $(PROGRAM_NAME) dynamic_jc ljc_vercheck_dynamic

dynamic_jc: $(PROGRAM_NAME) ljc_vercheck_dynamic
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(BDYNAMIC) $(DYN_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)

static_jc: $(PROGRAM_NAME) ljc_vercheck_static
	$(CC) $(CFLAGS) $(OBJS) $(LDFLAGS) $(BSTATIC) $(STATIC_LDFLAGS) $(BDYNAMIC) -o $(PROGRAM_NAME)$(SUFFIX)

static: $(PROGRAM_NAME) ljc_vercheck_static
	$(CC) $(CFLAGS) $(OBJS) -static $(LDFLAGS) $(BSTATIC) $(STATIC_LDFLAGS) -o $(PROGRAM_NAME)$(SUFFIX)

static_stripped: $(PROGRAM_NAME) static_jc
	-strip $(PROGRAM_NAME)$(SUFFIX)

$(PROGRAM_NAME): $(OBJS)
	@:

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(BIN_DIR) || $(MKDIR) $(DESTDIR)$(BIN_DIR)
	test -e $(DESTDIR)$(MAN_DIR) || $(MKDIR) $(DESTDIR)$(MAN_DIR)

install: $(PROGRAM_NAME) installdirs
	$(INSTALL_PROGRAM)	$(PROGRAM_NAME)$(SUFFIX)   $(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)$(SUFFIX)
	$(INSTALL_DATA)		$(PROGRAM_NAME).1 $(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

uninstalldirs:
	-test -e $(DESTDIR)$(BIN_DIR) && $(RMDIR) $(DESTDIR)$(BIN_DIR)
	-test -e $(DESTDIR)$(MAN_DIR) && $(RMDIR) $(DESTDIR)$(MAN_DIR)

uninstall: uninstalldirs
	$(RM)	$(DESTDIR)$(BIN_DIR)/$(PROGRAM_NAME)$(SUFFIX)
	$(RM)	$(DESTDIR)$(MAN_DIR)/$(PROGRAM_NAME).$(MAN_EXT)

test:
	./test.sh

stripped: $(PROGRAM_NAME) dynamic_jc
	strip $(PROGRAM_NAME)$(SUFFIX)

clean:
	$(RM) $(OBJS) $(OBJS_CLEAN) $(PROGRAM_NAME)$(SUFFIX) ljc_vercheck$(SUFFIX) \
		*~ .*.un~ *.gcno *.gcda *.gcov *.obj

distclean: clean
	$(RM) -rf *.pkg.tar* $(PROGRAM_NAME)-*-*/ $(PROGRAM_NAME)-*-*.zip

.PHONY: ljc_vercheck_static ljc_vercheck_dynamic

ljc_vercheck_dynamic:
	$(CC) $(CFLAGS) $(CPPFLAGS) libjodycode_check.c -DSTANDALONE $(LDFLAGS) $(LJC_DYNAMIC) -o ljc_vercheck$(SUFFIX)
	@echo
	@./ljc_vercheck 2>/dev/null || echo "Version check failed. Install libjodycode on the system and try again."
	@if [ `(./ljc_vercheck$(SUFFIX) 2>/dev/null || echo ":0:0:0:0") | cut -d: -f4` -lt `grep MY_FEATURELEVEL_REQ libjodycode_check.h | cut -d" " -f3` ]; \
		then echo "The linked libjodycode feature level is too old. Get the latest libjodycode and try again."; \
		else echo "The linked libjodycode feature level is OK."; \
	fi
	@echo

ljc_vercheck_static:
	$(CC) $(CFLAGS) $(CPPFLAGS) libjodycode_check.c -DSTANDALONE $(LDFLAGS) $(BSTATIC) $(STATIC_LDFLAGS) $(BDYNAMIC) -o ljc_vercheck$(SUFFIX)
	@echo
	@./ljc_vercheck 2>/dev/null
	@if [ `(./ljc_vercheck$(SUFFIX) 2>/dev/null || echo ":0:0:0:0") | cut -d: -f4` -lt `grep MY_FEATURELEVEL_REQ libjodycode_check.h | cut -d" " -f3` ]; \
		then echo "The linked libjodycode feature level is too old. Get the latest libjodycode and try again."; \
		else echo "The linked libjodycode feature level is OK."; \
	fi
	@echo

libjodycode_hint:
	$(info hint: if ../libjodycode is built but the program won't run, try doing 'make static_jc')

=== debian/changelog ===
libjodycode (4.1.1-1) unstable; urgency=medium

  * New upstream version 4.1.1.
  * debian/patches/: removed the following patches because the upstream fixed
    the source code (thanks!):
      - 010_fix-FTBFS.patch
      - 020_fix-manpage-level.patch

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 29 Oct 2025 07:39:16 -0300

=== debian/control ===
Source: libjodycode
Section: libs
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: https://codeberg.org/jbruchon/libjodycode
Vcs-Browser: https://salsa.debian.org/debian/libjodycode
Vcs-Git: https://salsa.debian.org/debian/libjodycode.git

Package: libjodycode4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libjodycode4t64
Breaks: libjodycode4t64
Description: shared lib for programs written by Jody Bruchon (runtime)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the runtime for libjodycode.

Package: libjodycode-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libjodycode4 (= ${binary:Version})
Replaces: libjoycode4 (<= 4.0.1-7.1)
Breaks: libjoycode4 (<= 4.0.1-7.1)
Description: shared lib for programs written by Jody Bruchon (development files)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the development files for libjodycode.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr LIB_DIR=/usr/lib/${DEB_TARGET_MULTIARCH}

## libjodycode 4.1.2

=== Makefile ===
--- 
+++ 
@@ -42,7 +42,12 @@
  endif
 endif
 
+# Are we running on macOS?
 ifeq ($(UNAME_S), Darwin)
+ ifndef NO_MACOS
+  ON_MACOS = 1
+  COMPILER_OPTIONS += -DON_MACOS=1
+ endif
  SO_SUFFIX    = .dylib
  SO_VER_FULL  = .$(VERSION)$(SO_SUFFIX)
  SO_VER_MAJOR = .$(VERSION_MAJOR)$(SO_SUFFIX)
@@ -225,7 +230,7 @@
 test:
 	./test.sh
 
-stripped: sharedlib staticlib
+stripped: sharedlib staticlib manual
 	$(STRIP_UNNEEDED) libjodycode$(SO_SUFFIX)
 	$(STRIP_DEBUG) libjodycode$(LIB_SUFFIX)

=== debian/changelog ===
libjodycode (4.1.2-1) unstable; urgency=medium

  * New upstream version 4.1.2.
  * debian/control:
      - Bumped Standards-Version to 4.7.3.
      - Removed no longer needed "Priority: optional" field.
  * debian/copyright:
      - Updated upstream and packaging copyright years.
      - Added a new licensing stanza.
  * debian/watch: migrated to version 5.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 11 Feb 2026 13:08:54 -0300

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: libjodycode
 Section: libs
-Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://codeberg.org/jbruchon/libjodycode
 Vcs-Browser: https://salsa.debian.org/debian/libjodycode
 Vcs-Git: https://salsa.debian.org/debian/libjodycode.git

=== debian/watch ===
Version: 5

Source: https://codeberg.org/jbruchon/libjodycode/tags
Matching-Pattern: archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
